import { ConNode, JsonNode, ValNode, ArrNode, BinNode, ObjNode, StrNode } from '../../../nodes';
import { ClockTable } from '../../../../json-crdt-patch/codec/clock/ClockTable';
import { CrdtReader } from '../../../../json-crdt-patch/util/binary/CrdtDecoder';
import { IndexedFields, IndexedNodeFields } from './types';
import { ITimestampStruct, IVectorClock } from '../../../../json-crdt-patch/clock';
import { Model } from '../../../model/Model';
import { MsgPackDecoderFast } from '../../../../json-pack/msgpack';
export declare class Decoder {
    readonly dec: MsgPackDecoderFast<CrdtReader>;
    protected doc: Model;
    protected clockTable?: ClockTable;
    decode<M extends Model>(fields: IndexedFields, ModelConstructor?: new (clock: IVectorClock) => M): M;
    decodeFields<M extends Model>(clockTable: ClockTable, fields: IndexedNodeFields, ModelConstructor?: new (clock: IVectorClock) => M): M;
    protected ts(): ITimestampStruct;
    protected decodeNode(id: ITimestampStruct): JsonNode;
    cConst(id: ITimestampStruct): ConNode;
    cVal(id: ITimestampStruct): ValNode;
    cObj(id: ITimestampStruct, length: number): ObjNode;
    protected cStr(id: ITimestampStruct, length: number): StrNode;
    protected cBin(id: ITimestampStruct, length: number): BinNode;
    protected cArr(id: ITimestampStruct, length: number): ArrNode;
}
