import { ITimestampStruct } from '../../../../json-crdt-patch/clock';
import { ClockTable } from '../../../../json-crdt-patch/codec/clock/ClockTable';
import { CrdtWriter } from '../../../../json-crdt-patch/util/binary/CrdtEncoder';
import { MsgPackEncoder } from '../../../../json-pack/msgpack';
import { Model } from '../../../model';
import { ConNode, JsonNode, ValNode, ArrNode, BinNode, ObjNode, StrNode } from '../../../nodes';
import { IndexedFields } from './types';
export declare class Encoder {
    protected clockTable?: ClockTable;
    readonly enc: MsgPackEncoder<CrdtWriter>;
    protected model?: IndexedFields;
    encode(doc: Model, clockTable?: ClockTable): IndexedFields;
    protected readonly onNode: (node: JsonNode) => void;
    encodeNode(node: JsonNode): Uint8Array;
    protected ts(id: ITimestampStruct): void;
    encodeVal(node: ValNode): Uint8Array;
    encodeConst(node: ConNode): Uint8Array;
    encodeStr(node: StrNode): Uint8Array;
    encodeBin(node: BinNode): Uint8Array;
    encodeObj(node: ObjNode): Uint8Array;
    protected readonly onObjectKey: (value: ITimestampStruct, key: string) => void;
    encodeArr(node: ArrNode): Uint8Array;
}
