import { ClockDecoder } from '../../../../json-crdt-patch/codec/clock/ClockDecoder';
import { CrdtReader } from '../../../../json-crdt-patch/util/binary/CrdtDecoder';
import { ITimestampStruct } from '../../../../json-crdt-patch/clock';
import { Model } from '../../../model/Model';
import { MsgPackDecoderFast } from '../../../../json-pack/msgpack';
import { ArrNode, BinNode, ObjNode, StrNode, VecNode, type JsonNode } from '../../../nodes';
export declare class Decoder extends MsgPackDecoderFast<CrdtReader> {
    protected doc: Model;
    protected clockDecoder?: ClockDecoder;
    protected time: number;
    constructor();
    decode(data: Uint8Array): Model;
    protected decodeClockTable(): void;
    protected ts(): ITimestampStruct;
    protected cRoot(): JsonNode;
    cNode(): JsonNode;
    cObj(id: ITimestampStruct, length: number): ObjNode;
    private cObjChunk;
    cTup(id: ITimestampStruct): VecNode;
    cArr(id: ITimestampStruct, length: number): ArrNode;
    private readonly cArrChunk;
    cStr(id: ITimestampStruct, length: number): StrNode;
    private cStrChunk;
    cBin(id: ITimestampStruct, length: number): BinNode;
    private cBinChunk;
}
