import { ConNode, RootNode, JsonNode, ValNode, VecNode, ArrNode, BinNode, ObjNode, StrNode } from '../../../nodes';
import { ClockEncoder } from '../../../../json-crdt-patch/codec/clock/ClockEncoder';
import { CrdtWriter } from '../../../../json-crdt-patch/util/binary/CrdtEncoder';
import { ITimestampStruct } from '../../../../json-crdt-patch/clock';
import { MsgPackEncoder } from '../../../../json-pack/msgpack';
import type { Model } from '../../../model';
export declare class Encoder extends MsgPackEncoder<CrdtWriter> {
    protected clockEncoder: ClockEncoder;
    protected time: number;
    protected doc: Model;
    constructor();
    encode(doc: Model<any>): Uint8Array;
    encodeLogical(model: Model): void;
    encodeServer(model: Model): void;
    protected encodeClockTable(x0: number, x: number): void;
    protected readonly cTableEntry: (entry: {
        clock: ITimestampStruct;
    }) => void;
    protected readonly tsLogical: (ts: ITimestampStruct) => void;
    protected readonly tsServer: (ts: ITimestampStruct) => void;
    protected ts: (ts: ITimestampStruct) => void;
    protected cRoot(root: RootNode): void;
    protected cNode(node: JsonNode): void;
    protected cObj(obj: ObjNode): void;
    protected readonly cKey: (val: ITimestampStruct, key: string) => void;
    protected cTup(obj: VecNode): void;
    protected cArr(obj: ArrNode): void;
    protected cStr(obj: StrNode): void;
    protected cBin(obj: BinNode): void;
    protected cVal(obj: ValNode): void;
    protected cConst(obj: ConNode): void;
}
