import * as nodes from '../../../nodes';
import { ITimestampStruct, VectorClock } from '../../../../json-crdt-patch/clock';
import { Model } from '../../../model';
import { JsonCrdtNode, ObjectJsonCrdtNode, ArrayJsonCrdtNode, ValueJsonCrdtNode, StringJsonCrdtNode, ConstantJsonCrdtNode, BinaryJsonCrdtNode, JsonCrdtSnapshot, JsonCrdtLogicalTimestamp, JsonCrdtTimestamp, TupleJsonCrdtNode } from './types';
export declare class Decoder {
    decode({ time, root }: JsonCrdtSnapshot): Model;
    protected cClock(timestamps: JsonCrdtLogicalTimestamp[]): VectorClock;
    protected cTs(stamp: JsonCrdtTimestamp): ITimestampStruct;
    protected cRoot(doc: Model, { node }: ValueJsonCrdtNode): void;
    protected cNode(doc: Model, node: JsonCrdtNode): nodes.JsonNode;
    protected cObj(doc: Model, node: ObjectJsonCrdtNode): nodes.ObjNode;
    protected cTup(doc: Model, node: TupleJsonCrdtNode): nodes.VecNode;
    protected cArr(doc: Model, node: ArrayJsonCrdtNode): nodes.ArrNode;
    protected cStr(doc: Model, node: StringJsonCrdtNode): nodes.StrNode;
    protected cBin(doc: Model, node: BinaryJsonCrdtNode): nodes.BinNode;
    protected cVal(doc: Model, node: ValueJsonCrdtNode): nodes.ValNode;
    protected cConst(doc: Model, node: ConstantJsonCrdtNode): nodes.ConNode;
}
