import * as nodes from '../../../nodes';
import { ITimestampStruct, IVectorClock } from '../../../../json-crdt-patch/clock';
import { Model } from '../../../model';
import type { JsonCrdtNode, ObjectJsonCrdtNode, ArrayJsonCrdtNode, ArrayJsonCrdtChunk, JsonCrdtRgaTombstone, ValueJsonCrdtNode, StringJsonCrdtNode, StringJsonCrdtChunk, ConstantJsonCrdtNode, BinaryJsonCrdtNode, BinaryJsonCrdtChunk, JsonCrdtLogicalTimestamp, JsonCrdtServerTimestamp, JsonCrdtSnapshot, TupleJsonCrdtNode } from './types';
export declare class Encoder {
    protected model: Model;
    encode(model: Model): JsonCrdtSnapshot;
    cClock(clock: IVectorClock): JsonCrdtLogicalTimestamp[];
    cTs(ts: ITimestampStruct): JsonCrdtLogicalTimestamp | JsonCrdtServerTimestamp;
    cNode(node: nodes.JsonNode): JsonCrdtNode;
    cObj(obj: nodes.ObjNode): ObjectJsonCrdtNode;
    cTup(obj: nodes.VecNode): TupleJsonCrdtNode;
    cArr(obj: nodes.ArrNode): ArrayJsonCrdtNode;
    cArrChunk(chunk: nodes.ArrChunk): ArrayJsonCrdtChunk | JsonCrdtRgaTombstone;
    cStr(obj: nodes.StrNode): StringJsonCrdtNode;
    cStrChunk(chunk: nodes.StrChunk): StringJsonCrdtChunk | JsonCrdtRgaTombstone;
    cBin(obj: nodes.BinNode): BinaryJsonCrdtNode;
    cBinChunk(chunk: nodes.BinChunk): BinaryJsonCrdtChunk | JsonCrdtRgaTombstone;
    cVal(obj: nodes.ValNode): ValueJsonCrdtNode;
    cConst(obj: nodes.ConNode): ConstantJsonCrdtNode;
}
